package com.example.gmailuidemo;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.crypto.spec.PSource;

import android.annotation.SuppressLint;
import android.app.ActionBar;
import android.app.ActionBar.OnNavigationListener;
import android.app.ActionBar.Tab;
import android.app.ActionBar.TabListener;
import android.app.Activity;
import android.app.Fragment;
import android.app.FragmentTransaction;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.ActionMode;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.ShareActionProvider;
import android.widget.SimpleAdapter;
import android.widget.Toast;

public class GmailActivity extends Activity{

	ActionBar actionBar;
	
	Map<String, String> datamap;
	
	List<Map<String, String>> datalist;
	MyAdapter dataAdapter;
	ListView mListView;
	ModeCallback mCallback;
	ArrayAdapter<String> mainAdapter;
	
	Button btn;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_gmail);
		
		

		
		mListView=(ListView)findViewById(R.id.mainList);
		String[] list=new String[]{"选项1","选项2","选项3","选项4"};
		mainAdapter=new ArrayAdapter<String>(GmailActivity.this, android.R.layout.simple_list_item_1, list);
		mListView.setAdapter(mainAdapter);
		mCallback=new ModeCallback();
		mListView.setChoiceMode(ListView.CHOICE_MODE_MULTIPLE_MODAL);
		mListView.setMultiChoiceModeListener(mCallback);
		
		actionBar=getActionBar();
		//dont show the title
		//actionBar.setDisplayShowTitleEnabled(false);
		//actionBar.setDisplayShowHomeEnabled(false);
//		actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);
		
		List<Info> pList=new ArrayList<Info>();
		
		Info info=new Info("标题1","23");
		pList.add(info);
		
		info=new Info("标题2","1");
		pList.add(info);
		
		info=new Info("标题3","54");
		pList.add(info);
		
	    info=new Info("标题4","6");
		pList.add(info);
		dataAdapter=new MyAdapter(this, pList);

		OnNavigationListener callback = new MyOnNavigationListener(); 
		actionBar.setListNavigationCallbacks(dataAdapter, callback);
		
        // 生成Tab
//        Tab edit = actionBar.newTab().setText("Tab B");
//        Tab computer = actionBar.newTab().setText("Tab A");
        // 为每个Tab添加Listener
//        MyTabListener editListener = new MyTabListener(new AFragment());
//        edit.setTabListener(editListener);
//        MyTabListener computerListener = new MyTabListener(new BFragment());
//        computer.setTabListener(computerListener);
        // 将Tab加入ActionBar中
//        actionBar.addTab(edit);
//        actionBar.addTab(computer);
		
	}

	@SuppressLint("NewApi") @Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.gmail, menu);
		
		View view=menu.findItem(R.id.menu_search).getActionView();
		btn=(Button) view.findViewById(R.id.colla_btn);
		btn.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				Toast.makeText(GmailActivity.this, "BTNTBTNT", Toast.LENGTH_LONG).show();
			}
		});
		
		ShareActionProvider mShareActionProvider=(ShareActionProvider) menu.findItem(R.id.share).getActionProvider();
		 mShareActionProvider.setShareIntent(getDefaultShareIntent());
		return true;
	}

	private Intent getDefaultShareIntent() {
		// TODO Auto-generated method stub
		Intent intent = new Intent(Intent.ACTION_SEND);
		intent.setType("text/plain");
		intent.putExtra(Intent.EXTRA_SUBJECT, "test");
		intent.putExtra(Intent.EXTRA_TEXT, "testest");
		intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		return intent;
	}
	
	/**
	 * 实现ActionBar.TabListener接口，构造函数中把fragment传进来了，为了更好的控制fragment
	 */
	class MyTabListener implements TabListener {
		// 接收每个Tab对应的Fragment，操作
		private Fragment fragment;

		public MyTabListener(Fragment fragment) {
			this.fragment = fragment;
		}

		@Override
		public void onTabReselected(Tab tab, FragmentTransaction ft) {
		}

		@Override
		// 当Tab被选中的时候添加对应的Fragment
		public void onTabSelected(Tab tab, FragmentTransaction ft) {
//			ft.replace(R.id.frame_place, fragment, null); 
			// 这里要不然使用
														
			// ft.replace(R.id.context,fragment, null)，之后不能使用commit(),要不然会报错。或者注释这条语句，使用下面注释的语句

			// FragmentTransaction fragmentTransaction =getFragmentManager().beginTransaction();
			// 试用fragment替换activity中的main组件
			// fragmentTransaction.replace(R.id.context, fragment);
			// 提交事物
			// fragmentTransaction.commit();
			// 提交事物

		}

		// 当Tab没被选中的时候删除对应的此Tab对应的Fragment
		@Override
		public void onTabUnselected(Tab tab, FragmentTransaction ft) {
			ft.remove(fragment);
		}

	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// TODO Auto-generated method stub
		switch(item.getItemId()){
		case R.id.menu_email:{
			Toast.makeText(this, "OKOKO", Toast.LENGTH_LONG).show();
			Intent intent=new Intent(this,TestActivity.class);
			startActivity(intent);
			break;
		}
		}
		return super.onOptionsItemSelected(item);
	}




	private class MyOnNavigationListener implements OnNavigationListener {  
		  
        @Override  
        public boolean onNavigationItemSelected(int itemPosition, long itemId) {  
  
            Toast.makeText(getApplicationContext(),  
                    "当前选择了：" + itemPosition, 0).show();  
  
            return true;  
        }  
        
    }  
	private class ModeCallback implements ListView.MultiChoiceModeListener {

		//
		
		@Override
		public boolean onActionItemClicked(ActionMode mode, MenuItem item) {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public boolean onCreateActionMode(ActionMode mode, Menu menu) {
			Log.d("GmailActivity", "oncreateactionmode");
			MenuInflater inflater = getMenuInflater();
			inflater.inflate(R.menu.action_mode_menu, menu);
			
			return true;
		}

		@Override
		public void onDestroyActionMode(ActionMode mode) {
			// TODO Auto-generated method stub
			Log.d("GmailActivity", "ondestroyActionMode");
			
		}

		@Override
		public boolean onPrepareActionMode(ActionMode mode, Menu menu) {
			Log.d("GmailActivity", "onPrepareActionMode");
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public void onItemCheckedStateChanged(ActionMode mode, int position,
				long id, boolean checked) {
			// TODO Auto-generated method stub
			
				mListView.setSelection(position);
				Log.d("sss","position"+position);
			
			
		}
		
	}

}
